/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"

static int cancelFunction(GtkWidget *widget, GtkWidget *win )
{
    gtk_widget_destroy(win);
}

int create_messageWin ( GtkWidget *win, char *message )
{
  GtkWidget *messageWin;
  GtkWidget *vbox1;
  GtkWidget *hbox2;
  GtkWidget *messageName;
  GtkWidget *hbox1;
  GtkWidget *canBtn;
  int       x,y,w,h;

#if 0
  gdk_window_get_origin(win->window, &x, &y);
  gdk_window_get_size  (win->window, &w, &h);
#else
  w = gdk_screen_width();
  h = gdk_screen_height();
  x = w * 0.5;
  y = h * 0.5;
#endif

  messageWin = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (messageWin), "messageWin", messageWin);
  gtk_window_set_title (GTK_WINDOW (messageWin), "å");
  gtk_widget_set_usize(messageWin, 100, 130);
  gtk_window_set_default_size(GTK_WINDOW(messageWin),400,100);
#if 0
  gtk_widget_set_uposition(messageWin,
        (x+(w/2)) - (400/2), (y+(h/2)) - (130/2));
#else
  gtk_widget_set_uposition(messageWin, (x - 400*0.5), (y - 130*0.5) );
#endif

  gtk_widget_show (messageWin);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (messageWin), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (messageWin), vbox1);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (messageWin), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, TRUE, TRUE, 20);

  messageName = gtk_label_new (message);
  gtk_widget_ref (messageName);
  gtk_object_set_data_full (GTK_OBJECT (messageWin), "messageName", messageName,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (messageName);
  gtk_box_pack_start (GTK_BOX (hbox2), messageName, TRUE, FALSE, 5);
  gtk_label_set_line_wrap (GTK_LABEL (messageName), TRUE);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (messageWin), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, TRUE, 10);

  canBtn = gtk_button_new_with_label (" Ĥ ");
  gtk_widget_ref (canBtn);
  gtk_object_set_data_full (GTK_OBJECT (messageWin), "canBtn", canBtn,
                            (GtkDestroyNotify) gtk_widget_unref);
    gtk_signal_connect (GTK_OBJECT (canBtn), "clicked",
	(GtkSignalFunc) cancelFunction, messageWin );

  gtk_widget_show (canBtn);
  gtk_box_pack_start (GTK_BOX (hbox1), canBtn, TRUE, FALSE, 0);

}
