/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxpbackup.h"

extern CxpBackup *cxpbackup ;

static GtkWidget *messWin = NULL;

static void message_destroy(GtkWidget *widget, gpointer data)
{
  /* ɥϥɤ */
  gtk_grab_remove ( messWin );
  gtk_widget_hide( messWin );
  messWin = (GtkWidget *)NULL ;
}

messageView( char *message )
{
  GtkWidget *vbox1;
  GtkWidget *hbox1;
  GtkWidget *messageLabel;
  GtkWidget *hbox2;
  GtkWidget *canBtn;
  int x,y,w,h ;

  w = gdk_screen_width();
  h = gdk_screen_height();
  x = w * 0.5;
  y = h * 0.5;

  if ( messWin != (GtkWidget *)NULL )
  {
	gtk_grab_remove ( messWin );
	gtk_widget_hide( messWin );
  }

  messWin = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (messWin), "messWin", messWin);
  gtk_widget_set_usize (messWin, 500, 90);
  gtk_window_set_title (GTK_WINDOW (messWin), "å");
  gtk_window_set_modal (GTK_WINDOW (messWin), TRUE);
  gtk_widget_set_uposition(messWin, (x - 500*0.5), (y - 90*0.5));
  gtk_widget_show (messWin);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (messWin), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (messWin), vbox1);

  hbox1 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (messWin), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, TRUE, 15);

  messageLabel = gtk_label_new ( message );
  gtk_widget_ref (messageLabel);
  gtk_object_set_data_full (GTK_OBJECT (messWin), "messageLabel", messageLabel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (messageLabel);
  gtk_box_pack_start (GTK_BOX (hbox1), messageLabel, FALSE, FALSE, 0);

  hbox2 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (messWin), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, FALSE, TRUE, 5);

  canBtn = gtk_button_new_with_label (" Ĥ ");
  gtk_widget_ref (canBtn);
  gtk_object_set_data_full (GTK_OBJECT (messWin), "canBtn", canBtn,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (canBtn);
  gtk_box_pack_start (GTK_BOX (hbox2), canBtn, FALSE, FALSE, 0);

  gtk_signal_connect_object (GTK_OBJECT (canBtn), "clicked",
                        (GtkSignalFunc) message_destroy,
                        GTK_OBJECT (messWin));

  gtk_signal_connect(GTK_OBJECT(messWin), "destroy",
                     GTK_SIGNAL_FUNC(message_destroy), NULL);


}

