/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxplorer.h"

extern CxpMgr *cxpmgr ;

static GtkWidget *settiong_win;
static GtkWidget *chkBtn_dotfile;
static GtkWidget *chkBtn_execfile;
static GtkWidget *setBtn;
static GtkWidget *canBtn;

static void setBtnCallBack(GtkWidget *widget, gpointer data ) 
{
    int status ;

    if (GTK_TOGGLE_BUTTON(chkBtn_dotfile)->active)
        cxpmgr->cinf.dotFlag = 1 ;
    else
        cxpmgr->cinf.dotFlag = 0 ;

#if 0
    if (GTK_TOGGLE_BUTTON(chkBtn_execfile)->active)
        cxpmgr->cinf.execFlag = 1 ;
    else
        cxpmgr->cinf.execFlag = 0 ;
#else
        cxpmgr->cinf.execFlag = 0 ;
#endif

    setCxplorerInfo( &cxpmgr->cinf );

    CxpDirView("");

    gtk_widget_destroy(settiong_win);
 
}

static void canBtnCallBack(GtkWidget *widget, gpointer data ) 
{
    gtk_widget_destroy(settiong_win);
}

int create_setting ()
{
  GtkWidget *vbox1;
  GtkWidget *notebook2;
  GtkWidget *vbox2;
  GtkWidget *hbox2;
  GtkWidget *label4;
  GtkWidget *hbox3;
  GtkWidget *label6;
  GtkWidget *label1;
  GtkWidget *hbox1;

  settiong_win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (settiong_win), "settiong_win", settiong_win);
  gtk_window_set_title (GTK_WINDOW (settiong_win), "");
  gtk_widget_show(settiong_win);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (settiong_win), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (settiong_win), vbox1);

  notebook2 = gtk_notebook_new ();
  gtk_widget_ref (notebook2);
  gtk_object_set_data_full (GTK_OBJECT (settiong_win), "notebook2", notebook2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (notebook2);
  gtk_box_pack_start (GTK_BOX (vbox1), notebook2, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (notebook2), 5);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (settiong_win), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (notebook2), vbox2);
  gtk_container_set_border_width (GTK_CONTAINER (vbox2), 5);

  hbox2 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (settiong_win), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox2, FALSE, TRUE, 0);

  label4 = gtk_label_new ("ɥåȥե");
  gtk_widget_ref (label4);
  gtk_object_set_data_full (GTK_OBJECT (settiong_win), "label4", label4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label4);
  gtk_box_pack_start (GTK_BOX (hbox2), label4, FALSE, FALSE, 0);

  chkBtn_dotfile = gtk_check_button_new_with_label ("ɽ");
  gtk_widget_ref (chkBtn_dotfile);
  gtk_object_set_data_full (GTK_OBJECT (settiong_win), "chkBtn_dotfile",
			chkBtn_dotfile, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (chkBtn_dotfile);
  gtk_box_pack_start (GTK_BOX (hbox2), chkBtn_dotfile, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (chkBtn_dotfile), TRUE);

#if 0
  hbox3 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox3);
  gtk_object_set_data_full (GTK_OBJECT (settiong_win), "hbox3", hbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox3, FALSE, TRUE, 0);

  label6 = gtk_label_new ("¹ԥե");
  gtk_widget_ref (label6);
  gtk_object_set_data_full (GTK_OBJECT (settiong_win), "label6", label6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label6);
  gtk_box_pack_start (GTK_BOX (hbox3), label6, FALSE, FALSE, 0);

  chkBtn_execfile = gtk_check_button_new_with_label ("ɽ");
  gtk_widget_ref (chkBtn_execfile);
  gtk_object_set_data_full (GTK_OBJECT (settiong_win), "chkBtn_execfile",
			chkBtn_execfile, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (chkBtn_execfile);
  gtk_box_pack_start (GTK_BOX (hbox3), chkBtn_execfile, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (chkBtn_execfile), TRUE);
#endif

  label1 = gtk_label_new ("ɽ");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (settiong_win), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook2),
		gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook2), 0), label1);

  hbox1 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (settiong_win), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, TRUE, 5);

  /*-- ܥ --*/
  setBtn = gtk_button_new_with_label ("  ");
  gtk_widget_ref (setBtn);
  gtk_object_set_data_full (GTK_OBJECT (settiong_win), "setBtn", setBtn,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_signal_connect_object (GTK_OBJECT (setBtn), "clicked",
        (GtkSignalFunc) setBtnCallBack, NULL );
  gtk_widget_show (setBtn);
  gtk_box_pack_start (GTK_BOX (hbox1), setBtn, FALSE, FALSE, 0);

  /*-- åܥ --*/
  canBtn = gtk_button_new_with_label ("  ");
  gtk_widget_ref (canBtn);
  gtk_object_set_data_full (GTK_OBJECT (settiong_win), "canBtn", canBtn,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_signal_connect_object (GTK_OBJECT (canBtn), "clicked",
        (GtkSignalFunc) canBtnCallBack, NULL );
  gtk_widget_show (canBtn);
  gtk_box_pack_start (GTK_BOX (hbox1), canBtn, FALSE, FALSE, 0);

  /*-- ɽ --*/
  if ( cxpmgr->cinf.dotFlag == 0 )
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(chkBtn_dotfile),0);
  else
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(chkBtn_dotfile),1);

#if 0
  if ( cxpmgr->cinf.execFlag == 0 )
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(chkBtn_execfile),0);
  else
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(chkBtn_execfile),1);
#endif
}

