/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxplorer.h"

/*
 * Cxplorer for UNIX Version Header
 *
 * version    date         log
 *    -.--    1998/05/05   thinking...
 *    0.00    1998/08/30   alpha release
 *    0.01    1998/11/20   beta release
 *    0.02    1998/11/21   version name modify
 *                         file directory click review bug fix.
 *                         menu click review bug fix.
 *    0.03    1998/11/21   smoll and itiran view position bug fix.
 *    0.04    1998/11/21   delete and rename permission check supported.
 *    0.05    1998/11/21   new file supported.
 *    0.06    1998/11/24   new directory supported.
 *    0.07    1998/11/24   cut and paste supported.
 *    0.08    1998/11/24   addr txt review bug fix.
 *    0.09    1998/11/25   add style menu.
 *    0.10    1998/11/25   initial style mode add.
 *    0.11    1998/11/25   makeinfo(date) modifyed.
 *    0.12    1998/11/25   init dir mode add.
 *    0.13    1998/11/26   xpm modify. back&arm color (none) supported.
 *    0.14    1998/11/27   tree line add .
 *    0.15    1998/12/11   very smoll bug fix.
 *    0.16    1998/12/19   smoll view mode delete review bug fix.
 *    0.17    1998/12/19   struct view special big update .
 *    0.18    1998/12/19   smoll speed up !!.
 *    0.19    1998/12/19   irix support .
 *    0.20    1998/12/19   sun sparc cntl redraw bug fix .
 *    0.21    1998/12/24   system infomation add.
 *    0.22    1998/12/29   all dialog modify.
 *    0.23    1998/12/29   propaty permission toggle chenge.
 *    0.24    1998/12/29   systeminfo supported linux system .
 *    0.25    1999/01/06   big icon position chenge.
 *                         date month +1 chenge.
 *    0.26    1999/01/08   propaty date month +1 chenge.
 *    0.27    1999/01/11   tree view on/off mode add.
 *    0.28    1999/01/13   open Cxplorer add.
 *                         -treeon/-treeoff command add.
 *    0.29    1999/01/27   user config file editer add.
 *    0.30    1999/01/28   user config edit error func add and ok add.
 *    0.31    1999/01/28   user config  xpm serch check add.
 *    0.32    1999/01/28   error dialog common .
 *    0.33    1999/02/20   button size change -> 32
 *    0.34    1999/03/02   XmText -> XmTextField KANJI bug.
 *    0.35    1999/03/02   XmTextFieldSet... -> XmTextFieldInsert
 *    0.36    1999/03/02   itiran view title button -> label chg.
 *    0.37    1999/03/03   exit call zero.
 *    0.38    1999/03/03   title width chg.
 *    0.39    1999/03/03   font style sun -> misc
 *    0.40    1999/03/03   opendir readdir closedir support
 *    0.41    1999/03/03   help add.
 *    0.42    1999/03/15   printcap editing add.(supported in linux)
 *    0.43    1999/03/15   cxpuedit printcap same editing
 *    Motif2.1 version delete ... 
 *
 *  (GTK+1.2 Version start)
 *    0.50    1999/08/15   cxplorer gtk+1.2 version release.
 *    1.0.0   1999/08/21   cxpnote add. and cxplorer new release.
 *    1.0.1   1999/08/24   cxpapp add.
 *    1.0.2   1999/09/05   menu accel add./list view bug fix
 *                         cxpnote menu accel add. ver1.0.1
 *    1.0.3   1999/09/07   cxppanel add. ver1.0.0
 *    1.0.4   1999/09/07   style add.
 *    1.0.5   1999/09/07   propaty bug fix. and propaty style changed.
 *                         cxpapp file dialog set bug fix.
 *    1.0.6   1999/09/11   style file add. (GNOME,KDE,Windows)
 *                         base xpm modify. bug fix.
 *    1.0.7   1999/09/14   cxppanel bug fix.
 *    1.0.8   1999/09/19   cxpsysinfo / cxpimage add.
 *                         directory cut&paste bug fix.
 *    1.1.0   1999/10/01   multiple select support.
 *                         new directory make bug fix.
 *                         cxpnote dos file(CR/LF) supported.
 *                         directory open NG bug fix.
 *                         cxpaddr add. ver1.0.0
 *                         file size bug fix.
 *                         cxpsysinfo text -> list change. ver1.0.1
 *    1.1.1   1999/10/02   cxplorer file list segmentation falt bug fix.
 *    1.1.2   1999/10/05   cxplorer file list multiple bug fix.
 *                         ctrl key supported.
 *    1.1.3   1999/10/16   cxpsysinfo vmware loading bug fix. v1.0.2
 *                         cxpnote original font sel dlg add. v1.0.4
 *    1.1.4   1999/10/27   security bug fix.
 *    1.1.5   1999/11/01   cxplorer file click double exec bug fix.
 *    1.1.6   1999/11/12   cxpcalen add. v1.0.0
 *    1.1.7   1999/11/12   cxppanel bug fix. v1.0.2
 *                         cxpaddr sub menu add. v1.1.0
 *    1.1.8   1999/11/20   cxpnote review open add. v1.1.0
 *                         cxpnote save check add.
 *    1.1.9   1999/12/01   cxplorer file(name, size, date) sort add.
 *                         cxplorer alloc memory large -> small.
 *    1.2.0   1999/12/10   cxplorer small memory exec supported.(8MB)
 *                         cxplorer tree select manual coding.
 *                         cxpwm alpha release. (v0.4.0)
 *    1.2.1   2000/01/10   active install directory support.
 *                         /usr/local/cxplorer [/usr/local/bin] (default)
 *                         /usr/share/cxplorer [/usr/bin]
 *                         /opt/cxplorer       [/usr/bin]
 *                         make directory bug fix.
 *                         copy and paste bug fix.
 *    1.2.2   2000/02/07   #include <sys/types.h> add (FreeBSD)
 *                         cxppanel config file open error bug fix.
 *    1.2.3   2000/02/28   cxpnote color mode supported.
 *                         and review add. (v1.2.0)
 *                         source -> header (cxpcommon.h)
 *                         cxpimage search dir add (v1.1.0)
 *    1.2.4   2000/03/21   cxpcalc add.(v1.0.0)
 *                         src file moved and Makefile change.
 *    1.2.5   2000/04/07   cxpnote bug fix.(v1.2.1)
 *    1.2.6   2000/04/11   cxplorer setting menu add.(v1.2.6)
 *                         dot file view or not view add.
 *    1.2.7   2000/04/20   main exit code is ZERO add. (Thanks Masahiro Sakai)
 *                              cxpaddr    v1.1.1
 *                              cxpapp     v1.0.2
 *                              cxpcalc    v1.0.1
 *                              cxpcalen   v1.0.1
 *                              cxpimage   v1.1.1
 *                              cxpnote    v1.2.2
 *                              cxppanel   v1.0.5
 *                              cxpsysinfo v1.0.3
 *                         cxpcommon.h add (fcntl.h)
 *                         cxpnote GNOME application Drag and Drop supported.
 *                         (Thanks Masahiro Sakai) cxpnote.(v1.2.3)
 *
 *    1.3.0   2000/05/01   cxpmail add. (v1.0.0)
 *    1.3.1   2000/05/03   cxpmail 2nd exec error bug fix.
 *                         (v1.0.1)
 *    1.3.1a  2000/05/09   gnome-menu add.(Thanks Masahiro Sakai)
 *                         Please Check for contrib directory.
 *    1.3.2   2000/05/16   cxplorer key operation support.
 *                         cxpnote (v1.2.4)
 *                               window size save.(cxplorer same)
 *                         cxpmail (v1.0.2)
 *                               server mail delete/undelete add.
 *                               help message bug fix.
 *                               From: "" <xxx@yyy.co.jp> is "" delete.
 *                               To: konta<xxx.yyy.org> -> konta <xxx.yyy.org> chg.
 *                               Header MINE Encording Supported.
 *                               sousinzumi fw Supported.
 *                         cxpaddr (v1.1.2)
 *                               list junban chg. (name,email,jobs,tel)
 *
 *    1.3.3   2000/06/17   cxplorer send application add.
 *                               and application entry window add.
 *                         cut and paste segmentation error bug fix.
 *                         multiuser cut and paste bug fix.
 *                         review on root directory view bug fix.
 *                         function entry window add. and Cntl/FN func add.
 *                         cxpmail (v1.0.3)
 *                               encode area malloc 2 -> 3scale
 *                               title list no subeteno jyouhou wo alloc site itanode
 *                                   korewo tuneni hitotu no jyouhou dake memory alloc
 *                                   suruyouni sita. mae ha title ga 500 ken attatoki,
 *                                   memory wo 80MByte mo sennyuu siteita. kono kaisyu
 *                                   niyori 20MByte ika ni osaerukotoga dekiru.
 *                               thread exit attribute change. (DETACHD)
 *                               In-Reply-To: Add.
 *                               new atena and atena info view support.
 *                               nday mail delete add.
 *                               same mail not get add.
 *
 *    1.3.4   2000/07/01   cxplorer window manager destroy event support.
 *                               dialog modal set.
 *                         active install directory by Makefile.
 *                         cxpnote window maneger destroy event support.(v1.2.5)
 *                         cxpmail window manager destroy event support.(v1.0.4)
 *                               nday mail and same mail function bug fix.
 *                         cxpaddr dialog modal set. (v1.1.3)
 *                         all cxp source include header.
 *                         program name change (cxpimage -> cxpbg ) (v1.2.0)
 *                         cxpimage(image viewer) add.(v1.0.0)
 *                               support image type JPEG/TIFF/GIF/PNG/PSD/BMP
 *
 *    1.4.0   2000/08/05   cxpbackup add. (v1.0.0)
 *                         cxprestore add. (v1.0.0)
 *                         cxpdevide add. (v1.0.0)
 *                         cxpmanager add. (v1.0.0)
 *                         cxpmanager start add.
 *                             cxpmail (v1.0.5)
 *                             cxpnote (v1.2.6)
 *                             cxpimage (v1.0.1)
 *                             cxpsysinfo (v1.0.4)
 *                             cxpapp (v1.0.3)
 *                             cxpaddr (v1.1.4)
 *                             cxpbg (v1.2.1)
 *                             cxppanel (v1.0.6)
 *                             cxpcalen (v1.0.2)
 *                             cxpcalc (v1.0.2)
 *                         cxpapp XPM => ICON label name change.
 *                         cxplorer directory review big change .
 *                         cxplorer/cxpmail/cxpnote size setting add.
 *
 *    1.5.0   2000/10/09   cxpbackup device selection bug fix. (v1.0.1)
 *                         cxpresotre device selection buf fix. (v1.0.1)
 *                         cxpaddr modal delete. (v1.1.5)
 *                         cxpmail memory small used change. (v1.1.0)
 *                                 title area data month -1 bug fix.
 *                                 kakikake mail -> send mail error bug fix.
 *                                 title encoding buf gix.
 *                         cxpcalen big change. (v1.1.0)
 *                                 todo add.
 *                                 alarm add.
 *                                 orijinal callender.
 *                                     month view add.
 *                                     day view add.
 *                         cxplorer new style (cxp) add.
 *                         cxplorer new style (aqua) add.
 *                         cxplorer new style (fukuro) add.
 *                                 style read change.
 *                         cxpmessage add. (v1.0.0)
 *                         cxpmanager calen schedule add. (v1.1.0)
 *                                 and device conf another module.
 *                                 (cxpmanager_dev)
 *                                 style save add.
 *                         icon(xpm) file all change.
 *
 *    1.5.1   2000/10/10   install.sh kill command change. (v1.03)
 *                         cxpcalen kind change bug fix. (v1.1.1)
 *
 *    1.5.2   2000/10/11   install.sh cxpaddr link bug fix. (v1.04)
 *
 *    1.5.3   2000/10/16   cxpmail password file security fix.
 *    1.5.4   2001/01/30   Makefile update and /etc/cxp.conf change. (fot NetBSD)
 *                         stop at auto start cxpmamanger.
 *    1.5.5   2001/09/14   cxplorer click directory bug fix.
 *                         mail and homepage address change.
 *                         cxpmail title null support
 *
 */
static char	cxplorer_title[] = 
"Cxplorer Version 1.5.5 Sep./14/2001 (C)K.Hatakeda" ;

static char	cxplorerVersion[]= "Version 1.5.5 2001/09/14" ;
static char	cxplorerJVersion[]= "С 1.5.5 2001/09/14" ;
static char	cxplorerEmail[]  = "E-MAILhatakeda@mbm.sphere.ne.jp";
static char	cxplorerJEmail[] = "Ϣ衧hatakeda@mbm.sphere.ne.jp";
static char	cxplorerURL[]    = "URL : http://www1.sphere.ne.jp/hatakeda";
static char	cxplorerJURL[]   = "http://www1.sphere.ne.jp/hatakeda";
static char	cxplorerCopyright[] = "Copyright 1998-2001 Hatakeda";

char *getdataTitle()
{
	return(cxplorer_title);
}
char *getdataVersion()
{
	return(cxplorerVersion);
}
char *getdataJVersion()
{
	return(cxplorerJVersion);
}
char *getdataEmail()
{
	return(cxplorerEmail);
}
char *getdataJEmail()
{
	return(cxplorerJEmail);
}
char *getdataUrl()
{
	return(cxplorerURL);
}
char *getdataJUrl()
{
	return(cxplorerJURL);
}
char *getdataCopyright()
{
	return(cxplorerCopyright);
}
